#include <stdio.h>

#define MAX_SIZE 15000

typedef enum _boolean
{
	false = 0, true = 1
} bool;

bool IsPrimeNumber(int num)
{
    bool bPrime = true;
    int factor = num / 2;
    int i = 0;
    for(i = 2; i <= factor; i++)
    {
	if( (num % i) == 0)
	    bPrime = false;
    }
    return bPrime;
}

int GetPrimeFactors(int num, int *arrResult)
{
    int count = 0;
    int arr[MAX_SIZE];
    int i = 0;
    int idx = 0;

    for(i = 2; i <= num; i++)
    {
	if(IsPrimeNumber(i) == true)
	    arr[count++] = i;
    }

    while(1)
    {
	if(IsPrimeNumber(num) == true)
	{
	    arrResult[idx++] = num;
	    break;
	}
	for(i = count - 1; i >= 0; i--)
	{
	    if( (num % arr[i]) == 0)
	    {
		arrResult[idx++] = arr[i];
		num = num / arr[i];
		break;
	    }
	}
    }
    return idx;
}

int GetCommonPrimeFactors(int *arr1, int count1, int *arr2, int count2, int *arrResult)
{
    int idx = 0;
    int i = 0;
    int j = 0;

    for(i = 0; i < count1; i++)
    {
	for(j = 0; j < count2; j++)
	{
	    if(arr2[j] < 0)
		continue;
	    if(arr1[i] == arr2[j])
	    {
		arrResult[idx++] = arr1[i];
		arr1[i] = arr2[j] = -1;
	    }
	}
    }
    return idx;
}

int GetGCD(int num1, int num2, bool disp)
{
    int arr1[MAX_SIZE], arr2[MAX_SIZE], arrResult[MAX_SIZE];
    int i, j, k, countResult;
    int gcd = 0;

    int count1 = GetPrimeFactors(num1, arr1);
    int count2 = GetPrimeFactors(num2, arr2);

    if(disp == true)
    {
	printf("\nNumber1 %d =", num1);
	for(i = 0; i < count1; i++)
	{
	    printf("%d ", arr1[i]);
	    if(i != count1 - 1)
		printf(" * ");
	}


	printf("\nNumber2 $d =", num2);
	for(j = 0; j < count2; j++)
	{
	    printf("%d ", arr2[j]);
	    if(j != count2 - 1)
		printf(" * ");
	}
    }

    countResult = GetCommonPrimeFactors(arr1, count1, arr2, count2, arrResult);

    if(disp == true)
	printf("\nGCD(%d,%d) = ", num1, num2);

    gcd = 1;
    for(k = 0; k < countResult; k++)
    {
	if(disp == true)
	{
	    printf("%d", arrResult[k]);
	    if(k != countResult - 1)
		printf(" * ");
	}
	gcd *= arrResult[k];
    }
    if(disp == true)
	printf("\n\n");
    return gcd;
}

int GetLCM(int num1, long num2)
{
	printf("%d", (num1 * num2));
	printf("\n");
	return (num1 * num2) / GetGCD(num1, num2, false);
}

long main()
{
    long num1, num2;
    long gcd, lcm;

    printf("Enter First Number: ");
    scanf("%d", &num1);
    printf("Enter Second Number: ");
    scanf("%d", &num2);

    gcd = GetGCD(num1, num2, true);
    lcm = GetLCM(num1, num2);
    printf("\nGCD(%d,%d) = %d\n", num1, num2, gcd);
    printf("\nLCM(%d,%d) = %d\n\n\n", num1, num2, lcm);

    return 0;
}

